# RPM spec file for Snd

%define prefix   /usr

Summary:	A sound editor
Name:		snd
Version:	5
Release:	7
Copyright:	LGPL
Group:		Applications/Sound
Source:		ftp://ccrma-ftp.stanford.edu/pub/Lisp/snd-5.tar.gz
URL:		http://www-ccrma.stanford.edu/software/snd/
Vendor:		CCRMA/Music Stanford University
Packager:	Bill Schottstaedt <bil@ccrma.stanford.edu>
Docdir:         %{prefix}/doc

%description
Snd is a sound editor modelled loosely after Emacs and an old, sorely-missed
PDP-10 sound editor named Dpysnd. It can accommodate any number of sounds
each with any number of channels, and can be customized and extended
using Guile or Ruby. Snd is free (LGPL); the code is available via
anonymous ftp at ccrma-ftp.stanford.edu as pub/Lisp/snd-5.tar.gz.

%prep
%setup

%build
%ifos Linux
%ifarch i386
./configure --prefix=%{prefix} --with-static-motif=yes --with-static-gsl=yes --with-static-xm=yes
make
%else
make -f makefile.ppcrpm
%endif
%endif

%install
install -m 755 -o 0 -g 0 -d %{prefix}/local/bin/
install -m 755 -o 0 -g 0 snd %{prefix}/local/bin

%files
%defattr(-, root, root)
%doc *.Snd *.html *.png *.scm
%{prefix}/local/bin/snd

# to make the rpm file (since I keep forgetting):
#   make up-to-date snd-5.tar.gz (and clear /usr/lib/snd if any)
#   increment release number above (and in snd.h, README.Snd)
#   su root
#   cd /usr/src/redhat/SOURCES
#   cp -f /<wherever>/snd-5.tar.gz .
#   cd ../SPECS
#   cp -f /<wherever>/snd.spec .
#   rpm -ba snd.spec
#   /usr/src/redhat/BUILD/snd-5 is where the build occurs
#   end result in /usr/src/redhat/RPMS/i386 (binary) and /usr/src/redhat/SRPMS (source)
#   update version references in README.Snd, ftp:LISP.README, web:snd.html, snd.h, sourceforge index.html, configure.ac
#   linux-snd:  ./configure --with-static-gsl --with-static-motif --with-static-xm
#   sun-snd:    ./configure --with-static-gsl [and remove the -g switch]
